/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg3dtestapplication;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import javafx.geometry.BoundingBox;
import javafx.geometry.Bounds;
import javafx.geometry.Point2D;
import javafx.geometry.Point3D;
import javafx.scene.AmbientLight;
import javafx.scene.Node;
import javafx.scene.PointLight;
import javafx.scene.input.PickResult;
import javafx.scene.input.SwipeEvent;
import javafx.scene.input.TouchEvent;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Box;
import javafx.scene.shape.CullFace;
import javafx.scene.shape.DrawMode;
import javafx.scene.shape.Line;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.Sphere;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.transform.Transform;



/**
 *
 * @author henri
 */
public class BoxModelObject extends Xform {

    private final TriangleMesh mesh;
    private MeshView meshView;
    private final TriangleMesh model;

    private final Xform extrusionWidget;
    private ExtrusionWidget ew;
    private final Box selectionScaleWidget, selectionScaleWidget2;

    private final float modelScaleFactorX;
    private final float modelScaleFactorY;
    private final float modelScaleFactorZ;

    private float selectionHeight,selectionWidth;
    private float edgeScaleFactor;
    private float rangeH, rangeV;
    

    private boolean selected = false;

    private final boolean absoluteSelectionHeight = false;

    private Box c;
    private Xform bb; 

    private ArrayList<Point3D> vertices = new ArrayList<>();
    private ArrayList<Point3D> faces;

    private double cameraAngleX = 0;
    private double cameraAngleY = 0;
    
    private Point3D pivot = new Point3D(0,0,0);
   
    private double minX,minY,minZ,maxX,maxY,maxZ;
    
    private float modelMX, modelMY, modelMZ;

    private BoxModelObject(Builder builder) {
        super();
        this.faces = new ArrayList<>();
        this.model = builder.model;

        this.modelScaleFactorX = 3;
        this.modelScaleFactorY = 3;
        this.modelScaleFactorZ = 3;
        

        this.edgeScaleFactor = 1.0f;
        this.selectionHeight = 0.0f;
        this.selectionWidth = 0.0f;
        this.rangeH = 0.2f;
        this.rangeV = 0.2f;

        this.extrusionWidget = new Xform();
        this.getChildren().add(this.extrusionWidget);

        
        mesh = builder.model;
        for(int i = 0; i<mesh.getPoints().size();i++){
            mesh.getPoints().set(i, round(mesh.getPoints().get(i),3));
        }
        //flipNormals(mesh);
        //Hilfspunkte, für große Boundingbox
        float[] pointss = {100,-100,-100,-100,100,100};

        mesh.getPoints().addAll(pointss);
        
        meshView = new MeshView(mesh);
        
        meshView.setScaleX(modelScaleFactorX);
        meshView.setScaleY(modelScaleFactorY);
        meshView.setScaleZ(modelScaleFactorZ);
        
        PhongMaterial mat = new PhongMaterial();
        mat.setDiffuseColor(Color.rgb(240, 240, 240, 0.8));
        meshView.setMaterial(mat);
        meshView.setCullFace(CullFace.BACK);
        //meshView.setDrawMode(DrawMode.LINE);
        meshView.setUserData(this);
      
        meshView.setOnTouchPressed((TouchEvent event) ->{
            selectViewingSurface(event);
        });
        this.getChildren().addAll(meshView);
        vertices = getVertices(false);
        faces = getFaces(false);

        AmbientLight ambient = new AmbientLight();
        ambient.setColor(Color.rgb(50, 0, 50, 0.1));
        //this.getChildren().add(ambient);

        PointLight light = new PointLight();
        light.setColor(Color.rgb(50, 50, 50, 0.6));
        light.setTranslateY(-50);
        light.setTranslateX(-80);
        light.setTranslateZ(-80);
        //this.getChildren().add(light);
        

        selectionScaleWidget = new Box(1, 1, 1);
        selectionScaleWidget.setScaleX(7);
        selectionScaleWidget.setScaleZ(7);
        PhongMaterial mat2 = new PhongMaterial();
        mat2.setDiffuseColor(Color.rgb(10, 20, 20, 0.5));
        selectionScaleWidget.setMaterial(mat2);
        selectionScaleWidget.setCullFace(CullFace.NONE);
        selectionScaleWidget.setDrawMode(DrawMode.LINE);
        selectionScaleWidget.setTranslateY(this.selectionHeight);
        this.getChildren().add(selectionScaleWidget);
        selectionScaleWidget.setVisible(false);
        
        selectionScaleWidget2 = new Box(1, 1, 1);
        selectionScaleWidget2.setScaleY(7);
        selectionScaleWidget2.setScaleZ(7);
        PhongMaterial mat3 = new PhongMaterial();
        mat3.setDiffuseColor(Color.rgb(20, 20, 10, 0.5));
        selectionScaleWidget2.setMaterial(mat3);
        selectionScaleWidget2.setCullFace(CullFace.NONE);
        selectionScaleWidget2.setDrawMode(DrawMode.LINE);
        selectionScaleWidget2.setTranslateX(this.selectionWidth);
        this.getChildren().add(selectionScaleWidget2);
        selectionScaleWidget2.setVisible(false);
        

        
    }

    public void recalculateBounds(){
        vertices = getVertices(false);
        faces = getFaces(false);
        
        ArrayList<Point3D> delete = new ArrayList<>();
        ArrayList<Point3D> deletee = new ArrayList<>();
        delete.addAll(vertices);
        HashSet<Integer> deletes = new HashSet<>();
        for(Point3D f : faces){
            deletes.add((int)f.getX());

            deletes.add((int)f.getY());

            deletes.add((int)f.getZ());

        }
        for(Integer i : deletes){
            deletee.add(delete.get(i));
        }
        delete.removeAll(deletee);
        System.out.println("scaleY: "+this.s.getY());
        minX = 0;
        minY = 0;
        minZ = 0;
        maxX = 0;
        maxY = 0;
        maxZ = 0;
        for(Point3D p : deletee){
            double x = p.getX();
            double y = p.getY();
            double z = p.getZ();
            if(x < minX){
                minX = x;
            }    
            else if(x > maxX){
                maxX = x;
            }
            
            if(y < minY){
                minY = y;
            }    
            else if(y > maxY){
                maxY = y;
            }
            
            if(z < minZ){
                minZ = z;
            }    
            else if(z > maxZ){
                maxZ = z;
            }
        }
        

        
        System.out.println("New Bounds: "+minX+", "+minY+", "+minZ+", "+maxX+", "+maxY+", "+maxZ);
    }
    
    private void showSphere(double radius, Point3D location){
        Sphere s = new Sphere(radius);
        s.setTranslateX(location.getX());
        s.setTranslateY(location.getY());
        s.setTranslateZ(location.getZ());
        this.getChildren().add(s);
    }
    
    public double getHeight(){
        //return maxY*this.s.getY()-minY*this.s.getY();
        return maxY-minY;
    }
    
    public double getWidth(){
        return maxX-minX;
    }
    
    public double getDepth(){
        return maxZ-minZ;
    }
    
    public void setColor(Color c){
        PhongMaterial mat = new PhongMaterial();
        mat.setDiffuseColor(c);
        meshView.setMaterial(mat);
    }
    
    public PhongMaterial getColor(){
        return (PhongMaterial)meshView.getMaterial();
    }
    
    public void toggleWireframe(){
        if(this.meshView.getDrawMode() == DrawMode.LINE)
            this.meshView.setDrawMode(DrawMode.FILL);
        else
            this.meshView.setDrawMode(DrawMode.LINE);
    }
    
    public void setWireFrame(){
        this.meshView.setDrawMode(DrawMode.LINE);
    }

    private float round(double value, int places) {
        if (places < 0) {
            throw new IllegalArgumentException();
        }

        BigDecimal bd = new BigDecimal(value);
        bd = bd.setScale(places, RoundingMode.HALF_UP);
        return bd.floatValue();
    }
        
    public void setEW(ExtrusionWidget e){
        ew = e;
    }
    

    
    private Point3D selectViewingSurface(TouchEvent event){
        faces = getFaces(false);
        PickResult pr = event.getTouchPoint().getPickResult();
        int f = pr.getIntersectedFace();
        Point3D face = faces.get(f);
        Point3D a = vertices.get((int)face.getX());
        Point3D b = vertices.get((int)face.getY());
        Point3D c = vertices.get((int)face.getZ());
        Point3D s = ((a.add(b).add(c))).multiply(1/3d); 
        Point3D d = b.subtract(a);
        Point3D e = c.subtract(a);
        d = d.normalize();
        e = e.normalize();
        
        Point3D normal = d.crossProduct(e);
        
        normal = normal.normalize();
        
        if(ew != null){
            ew.setCamView(s, normal);
        }
        return normal;
    }
    
    public ExtrusionWidget getEW(){
        return this.ew;
    }
    
    public Xform getExtrusionWidgetContent() {
        return this.extrusionWidget;
    }

    public Box getSelectionWidget() {
        return this.selectionScaleWidget;
    }
    public Box getSelectionWidget2() {
        return this.selectionScaleWidget2;
    }

    public void setSelected(boolean isSelected) {
    
        this.selected = isSelected;
    }

    public boolean isSelected() {
        return this.selected;
    }

    public TriangleMesh getMesh() {
        return mesh;
    }
    
    public MeshView getMeshView(){
        return meshView;
    }

    public int getFaceIndex(Point3D face) {

        int index = -1;
        ArrayList<Point3D> facesl = getFaces(true);
        for (Point3D pp : facesl) {
            if (pp.getX() == face.getX() && pp.getY() == face.getY() && pp.getZ() == face.getZ()) {
                index = facesl.indexOf(pp);
            }
        }
        return index;
    }

    public ArrayList<Point3D> getVertices(boolean print) {
        
        vertices.clear();
        for (int i = 0; i < mesh.getPoints().size(); i += 3) {
            float x = mesh.getPoints().get(i);
            float y = mesh.getPoints().get(i + 1);
            float z = mesh.getPoints().get(i + 2);
            
            x *= modelScaleFactorX;
            y *= modelScaleFactorY;
            z *= modelScaleFactorZ;

            Point3D p = new Point3D(x, y, z);
            
            p.add(this.getTranslateX(), this.getTranslateY(), this.getTranslateZ());
            vertices.add(p);

        }
        //if(print)
            //System.out.println("get vertices: "+vertices.size());
        return vertices;
    }

    public ArrayList<Point3D> getFaces(boolean print) {
        faces.clear();
        int size = mesh.getFaces().size();
        for (int i = 0; i < size; i += 6) {
            double x = (double) mesh.getFaces().get(i);
            double y = (double) mesh.getFaces().get(i + 2);
            double z = (double) mesh.getFaces().get(i + 4);
            faces.add(new Point3D(x, y, z));
            
               
        }
        return faces;
    }

    public ArrayList<Point3D> getFacePoints(Point3D face) {
        Point3D a = getVertices(false).get((int) face.getX());
        Point3D b = getVertices(false).get((int) face.getY());
        Point3D c = getVertices(false).get((int) face.getZ());
        ArrayList<Point3D> points = new ArrayList<>();
        points.add(a);
        points.add(b);
        points.add(c);
        return points;
    }
    
    public Point3D getFaceNormal(Point3D face){
        ArrayList<Point3D> points = getFacePoints(face);
        
        Point3D a = points.get(1).subtract(points.get(0));
        Point3D b = points.get(2).subtract(points.get(0));
        Point3D normal = a.crossProduct(b);
        
        normal = normal.normalize();
        return normal;
    }

    public float getModelScaleFactorX() {
        return this.modelScaleFactorX;
    }

    public float getModelScaleFactorY() {
        return this.modelScaleFactorY;
    }

    public float getModelScaleFactorZ() {
        return this.modelScaleFactorZ;
    }

    public void setSelectionHeight(float height, float delta) {
        if (absoluteSelectionHeight) {
            this.selectionHeight = height;
            selectionScaleWidget.setTranslateY(-selectionScaleWidget.getTranslateY());
            selectionScaleWidget.setTranslateY(this.selectionHeight * (float) this.modelScaleFactorY);
        } else {
            double newSelectionHeight = selectionScaleWidget.getTranslateY() / this.modelScaleFactorY + delta;
            //selectionScaleWidget.setTranslateY(newSelectionHeight * (maxY-minY)/2);
            selectionScaleWidget.setTranslateY(selectionScaleWidget.getTranslateY() + delta);
            this.selectionHeight = (float) newSelectionHeight;
   
            if (selectionScaleWidget.getTranslateY() < (minY)) {
                
                selectionScaleWidget.setTranslateY(minY);
                this.selectionHeight = (float)minY/this.modelScaleFactorY;
            }

            if (selectionScaleWidget.getTranslateY() > (maxY)) {
                
                selectionScaleWidget.setTranslateY(maxY);
                this.selectionHeight = (float)maxY/this.modelScaleFactorY;
            }
        }
    }
    
    public void setSelectionWidth(float width, float delta) {

            double newSelectionWidth = selectionScaleWidget2.getTranslateX() / this.modelScaleFactorX + delta;
            //selectionScaleWidget.setTranslateY(newSelectionHeight * (maxY-minY)/2);
            selectionScaleWidget2.setTranslateX(selectionScaleWidget2.getTranslateX() + delta);
            this.selectionWidth = (float) newSelectionWidth;

            if (selectionScaleWidget2.getTranslateX() < (minX)) {
          
                selectionScaleWidget2.setTranslateX(minX);
                this.selectionWidth = (float)minX/this.modelScaleFactorX;
            }

            if (selectionScaleWidget2.getTranslateX() > (maxX)) {
              
                selectionScaleWidget2.setTranslateX(maxX);
                this.selectionWidth = (float)maxX/this.modelScaleFactorX;
            }
        
    }

    public void setScaleFactor(float factor, boolean horizontal) {
        this.edgeScaleFactor = factor;
        if(horizontal)
            scaleHorizontalEdgeLoop();
        else
            scaleVerticalEdgeLoop();
    }

    public void setRangeHorizontal(float range) {
        this.rangeH += range;
        this.selectionScaleWidget.setScaleY(this.selectionScaleWidget.getScaleY() + range * this.modelScaleFactorY);
    }
    public void setRangeVertical(float range) {
        this.rangeV += range;
        this.selectionScaleWidget2.setScaleX(this.selectionScaleWidget2.getScaleX() + range * this.modelScaleFactorX);
    }


    private void scaleHorizontalEdgeLoop() {
        boolean newMax = false;
        int numPoints = mesh.getPoints().size() / 3;

        for (int i = 0; i < numPoints; i++) {
            float x = mesh.getPoints().get(i * 3);
            float y = mesh.getPoints().get(i * 3 + 1);
            float z = mesh.getPoints().get(i * 3 + 2);

            //if(isInRange(z,this.selectionHeight,this.range)){
            if (containsVertex(this.selectionScaleWidget, x, y, z)) {

                float t = mesh.getPoints().get(i * 3) * this.edgeScaleFactor;
                float s = mesh.getPoints().get(i * 3 + 2) * this.edgeScaleFactor;
                
                if(t > modelMX){
                    modelMX = t;
                    newMax = true;
                }    
                mesh.getPoints().set(i * 3, t);
                mesh.getPoints().set(i * 3 + 2, s);

            }

        }
        
        if(this.edgeScaleFactor >= 1.0 && newMax){
            selectionScaleWidget.setScaleX(selectionScaleWidget.getScaleX() * this.edgeScaleFactor);
            selectionScaleWidget.setScaleZ(selectionScaleWidget.getScaleZ() * this.edgeScaleFactor);
        }
        

    }
        private void scaleVerticalEdgeLoop() {
        
        boolean newMax = false;    
        int numPoints = mesh.getPoints().size() / 3;

        for (int i = 0; i < numPoints; i++) {
            float x = mesh.getPoints().get(i * 3);
            float y = mesh.getPoints().get(i * 3 + 1);
            float z = mesh.getPoints().get(i * 3 + 2);

            //if(isInRange(z,this.selectionHeight,this.range)){
            if (containsVertex(this.selectionScaleWidget2, x, y, z)) {

                float t = mesh.getPoints().get(i * 3 +1) * this.edgeScaleFactor;
                float s = mesh.getPoints().get(i * 3 + 2) * this.edgeScaleFactor;
                
                if(t > modelMY){
                    modelMY = t;
                    newMax = true;
                }
                
                mesh.getPoints().set(i * 3 + 1, t);
                mesh.getPoints().set(i * 3 + 2, s);


            }

        }
        if(this.edgeScaleFactor >= 1.0 && newMax){
            selectionScaleWidget2.setScaleY(selectionScaleWidget2.getScaleY() * this.edgeScaleFactor);
            selectionScaleWidget2.setScaleZ(selectionScaleWidget2.getScaleZ() * this.edgeScaleFactor);
        }

    }

    private boolean containsVertex(Node n, float x, float y, float z) {
        Bounds b = n.getBoundsInParent();
        //b = this.meshView.parentToLocal(b);
        boolean contains = b.contains(new Point3D(x * this.modelScaleFactorX, y * this.modelScaleFactorY, z * this.modelScaleFactorZ));
        return contains;
    }


    public static class Builder {

        private final TriangleMesh model;

        public Builder(TriangleMesh model) {
            this.model = model;
        }

        public BoxModelObject build() {
            return new BoxModelObject(this);
        }

    }

}
