/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg3dtestapplication;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.stage.Stage;
import javafx.scene.PerspectiveCamera;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.geometry.Insets;
import javafx.geometry.Point3D;
import javafx.geometry.Pos;
import javafx.geometry.Rectangle2D;
import javafx.scene.AmbientLight;
import javafx.scene.input.MouseEvent;
import javafx.scene.Node;
import javafx.scene.PointLight;
import javafx.scene.SceneAntialiasing;
import javafx.scene.SubScene;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.PickResult;
import javafx.scene.input.SwipeEvent;
import javafx.scene.input.TouchEvent;
import javafx.scene.input.ZoomEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.CullFace;
import javafx.scene.shape.DrawMode;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.Sphere;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.transform.Affine;
import javafx.scene.transform.Transform;
import javafx.stage.FileChooser;
import javafx.stage.FileChooser.ExtensionFilter;
import javafx.stage.Screen;
import javafx.stage.StageStyle;


/**
 *
 * @author henri
 */
public class Main extends Application {

    final Xform world = new Xform();
   

    final Xform root = new Xform();
    final Group hor = new Group();

    final Group cam = new Group();

    private Group plane;

    private SubScene scene3D;
    
    private BorderPane border;
    
    private CameraViewOrtho cameraTopView, cameraSideView;
    private ScaleWidget scaleWidget;
    private ColorChooseWidget colorWidget;
    private HBox translateCameraViews;
    
    private BoxModelWidget bmw;
    private ExtrusionWidget ew;

    double mousePosX;
    double mousePosY;
    double mouseOldX;
    double mouseOldY;
    double mouseDeltaX;
    double mouseDeltaY;

    ArrayList<BoxModelObject> objects = new ArrayList<>();

    final PerspectiveCamera camera = new PerspectiveCamera(true);
    final Xform cameraXform = new Xform();
    final Xform cameraXform2 = new Xform();
    final Xform cameraXform3 = new Xform();
    final double cameraDistance = 50;
    
    private Stage stage;
    
    private void buildScene() {
        System.out.println("buildScene");
        AmbientLight ambient = new AmbientLight();
        ambient.setColor(Color.rgb(100,100,100,0.6));
        PointLight point = new PointLight();
        Sphere s = new Sphere(0.5);
        s.setMaterial(new PhongMaterial(Color.AZURE));
        s.setTranslateY(-15);
        s.setTranslateX(-8);
        s.setTranslateZ(-25);
        point.setColor(Color.rgb(255, 255, 255, 0.6));
        point.setTranslateY(-15);
        point.setTranslateX(-8);
        point.setTranslateZ(-25);
        //world.getChildren().add(s);
        world.getChildren().add(ambient);
        world.getChildren().add(point);
        
        world.getChildren().add(addGroundPlane());
        bmw = new BoxModelWidget.Builder(600, 0, 500, 500, "bmw").build();
        colorWidget = new ColorChooseWidget();
        
        world.setOnMousePressed((MouseEvent event) -> {
            PickResult p = new PickResult(event.getTarget(),event.getSceneX(),event.getSceneY());
            Node n = p.getIntersectedNode();
            if(n.getUserData() instanceof BoxModelObject){
                BoxModelObject bmo = (BoxModelObject)n.getUserData();
                for(BoxModelObject b: objects){
                    if(b.equals(bmo)){
                        selectB3d(bmo);
                    }
                }
            }
            
        });

        
        
    }

    private Group addGroundPlane() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader();
            fxmlLoader.setLocation(this.getClass().getResource("/resources/plane.fxml"));
            plane = fxmlLoader.<Group>load();
            MeshView meshView = (MeshView) plane.getChildren().get(0);
            PhongMaterial mat = new PhongMaterial();
            meshView.setScaleX(2);
            meshView.setScaleY(2);
            mat.setDiffuseColor(Color.rgb(240, 240, 240, 0.8));
            meshView.setMaterial(mat);
            meshView.setCullFace(CullFace.NONE);
            meshView.setDrawMode(DrawMode.LINE);
            plane.setDisable(true);

        } catch (IOException e) {
            // exception handling
        }
        return plane;
    }
    
    private TriangleMesh loadModel(String file){
        TriangleMesh object = null;
        try {
            FXMLLoader fxmlLoader = new FXMLLoader();
            fxmlLoader.setLocation(this.getClass().getResource("/resources/"+file));
            //MeshView meshView = fxmlLoader.<MeshView>load();
            Group group = fxmlLoader.<Group>load();
            MeshView meshView = (MeshView)group.getChildren().get(0);

            object = (TriangleMesh)meshView.getMesh();

        } catch (IOException e) {
            // exception handling
        }
        return object;
    }
    
    private TriangleMesh loadModelFromFile(File file){
        
        TriangleMesh object = null;
        try {
            FXMLLoader fxmlLoader = new FXMLLoader();
            fxmlLoader.setLocation(new URL("file:/"+file.getPath().replace("\\", "/")));
            Group group = fxmlLoader.<Group>load();
            MeshView meshView = (MeshView)group.getChildren().get(0);
            object = (TriangleMesh)meshView.getMesh();

        } catch (IOException e) {
            System.out.println("IOException");
            e.printStackTrace();
        }
        return object;
    }
    
    private void loadTransformationsFromFile(File file){
        
        TriangleMesh object = null;
        try {
            FXMLLoader fxmlLoader = new FXMLLoader();
            fxmlLoader.setLocation(new URL("file:/"+file.getPath().replace("\\", "/")));
            Group group = fxmlLoader.<Group>load();
            ObservableList<Node> children = group.getChildren();
            for(Node n : children){
                if(n instanceof MeshView){
                    MeshView m = (MeshView)n;
                    TriangleMesh tm = (TriangleMesh)m.getMesh();
                    
                    BoxModelObject bmo = new BoxModelObject.Builder(tm).build();                    
                    
                    float sx = 1.0f;
                    float sy = 1.0f;
                    float sz = 1.0f;
                    
                    float tx = 0.0f;
                    float ty = 0.0f;
                    float tz = 0.0f;
                    
                    float rx = 1.0f;
                    float ry = 1.0f;
                    float rz = 1.0f;
                    
                    Affine affine = new Affine();

                    ObservableList<Transform> trans = m.getTransforms();
                    for(Transform t:trans){
                        affine.append(t);
                    }
                    System.out.println("Affine: "+affine);
                    //bmo.getTransforms().addAll(trans);
                    
                    double sxx = Math.sqrt((affine.getMxx()*affine.getMxx()+affine.getMyx()*affine.getMyx()+affine.getMzx()*affine.getMzx()));
                    double syy = Math.sqrt((affine.getMxy()*affine.getMxy()+affine.getMyy()*affine.getMyy()+affine.getMzy()*affine.getMzy()));
                    double szz = Math.sqrt((affine.getMxz()*affine.getMxz()+affine.getMyz()*affine.getMyz()+affine.getMzz()*affine.getMzz()));
                    
                    bmo.s.setX(sxx);
                    bmo.s.setY(syy);
                    bmo.s.setZ(szz);
                    
                    bmo.t.setX(affine.getTx());
                    bmo.t.setY(affine.getTy());
                    bmo.t.setZ(affine.getTz());
                    
                    double rxx = Math.toDegrees(Math.atan2(affine.getMzy(), affine.getMzz()));
                    double ryy = Math.toDegrees(Math.atan2(-affine.getMzx(), Math.sqrt((affine.getMzy()*affine.getMzy() + affine.getMzz()*affine.getMzz()))));
                    double rzz = Math.toDegrees(Math.atan2(affine.getMyx(), affine.getMxx()));
                    
                    
                    //System.out.println("Scales: "+sxx+", "+syy+", "+szz);
                    //System.out.println("Angles: "+rxx+", "+ryy+", "+rzz);
                    
                    bmo.rx.setAngle(rxx);
                    bmo.ry.setAngle(ryy);
                    bmo.rz.setAngle(rzz);
                    
                    PhongMaterial pm = (PhongMaterial)m.getMaterial();
                    Color c = new Color(pm.getDiffuseColor().getRed(),pm.getDiffuseColor().getGreen(),pm.getDiffuseColor().getBlue(), 1.0);
                    bmo.setColor(c);
                    
                    objects.add(bmo);
                    selectB3d(bmo);
                    this.world.getChildren().add(bmo);
        
                    //System.out.println("New BMO "+objects.size());
                }
            }


        } catch (IOException e) {
            System.out.println("IOException");
            e.printStackTrace();
        }
     
    }
        
    private void loadB3DFromFile(File file){
        
        loadTransformationsFromFile(file);
        
    }
    
    private void loadB3D(String file){
        BoxModelObject bmo = new BoxModelObject.Builder(loadModel(file)).build();
        
        bmo.setOnSwipeLeft((SwipeEvent event) -> {
            BoxModelObject bmoCopy = new BoxModelObject.Builder(bmo.getMesh()).build();
            objects.add(bmoCopy);
            selectB3d(bmoCopy);
            this.world.getChildren().add(bmoCopy);
        });
        bmo.setOnSwipeDown((SwipeEvent event) -> {
            objects.remove(bmo);
            this.world.getChildren().remove(bmo);
        });
        objects.add(bmo);
        selectB3d(bmo);
        this.world.getChildren().add(bmo);
    }
    
    private void loadSceneFromFile(){
        FileChooser fileChooser = new FileChooser();
        fileChooser.setTitle("Open Resource File");
        fileChooser.getExtensionFilters().addAll(
                new ExtensionFilter("FXML Files", "*.fxml"));
        File selectedFile = fileChooser.showOpenDialog(stage);
        if (selectedFile != null) {
            
            loadB3DFromFile(selectedFile);
        }
    }

    private HBox addIconBox() {

        Image cubeImg = new Image(getClass().getResourceAsStream("/resources/cubeGrid.png"));
        ImageView cube = new ImageView(cubeImg);
       
        cube.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("cube.fxml");
        });
        
        Image cubeSimpleImg = new Image(getClass().getResourceAsStream("/resources/cube.png"));
        ImageView cubeSimple = new ImageView(cubeSimpleImg);
       
        cubeSimple.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("cube_simple.fxml");
        });

        Image sphereImg = new Image(getClass().getResourceAsStream("/resources/sphere.png"));
        ImageView sphere = new ImageView(sphereImg);
        sphere.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("sphere.fxml");
        });

        Image cylinderImg = new Image(getClass().getResourceAsStream("/resources/cylinder.png"));
        ImageView cylinder = new ImageView(cylinderImg);
        cylinder.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("cylinder.fxml");
        });

        Image coneImg = new Image(getClass().getResourceAsStream("/resources/cone.png"));
        ImageView cone = new ImageView(coneImg);
        cone.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("cone.fxml");
        });

        Image torusImg = new Image(getClass().getResourceAsStream("/resources/torus.png"));
        ImageView torus = new ImageView(torusImg);
        torus.setOnSwipeUp((SwipeEvent event) -> {
            loadB3D("torus.fxml");
        });
        
       


        HBox iconBox = new HBox(cube, cubeSimple, sphere, cylinder, cone, torus);
        iconBox.setSpacing(10);
        iconBox.setAlignment(Pos.CENTER);
        iconBox.setPadding(new Insets(20, 0, 20, 20));
        iconBox.addEventFilter(
            MouseEvent.ANY,
                new EventHandler<MouseEvent>() {
                    public void handle(final MouseEvent mouseEvent) {

                        mouseEvent.consume();

                    }
        });
        return iconBox;
    }
  
    private VBox addToolIcons() {

        Image modelImg = new Image(getClass().getResourceAsStream("/resources/model.png"));
        Button buttonModel = new Button();
        buttonModel.setGraphic(new ImageView(modelImg));

        buttonModel.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent e) {
                BoxModelObject b3d = getSelectedB3D();
                if (b3d != null) {
                    b3d.recalculateBounds();
                    border.setCenter(bmw);
                }

            }
        });
        
        Image colorImg = new Image(getClass().getResourceAsStream("/resources/colors.png"));
        Button buttonColor = new Button();
        buttonColor.setGraphic(new ImageView(colorImg));

        buttonColor.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
               BoxModelObject b3d = getSelectedB3D();
               if(b3d != null){
                colorWidget.setB3D(b3d);
                border.setCenter(colorWidget);
               }
                
            }
        });
        
        Image translateImg = new Image(getClass().getResourceAsStream("/resources/translate.png"));
        Button buttonTranslate = new Button();
        buttonTranslate.setGraphic(new ImageView(translateImg));

        buttonTranslate.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
                
               BoxModelObject b3d = getSelectedB3D();
               
               if(b3d != null){
                   cameraTopView.setB3D(b3d);
                   cameraSideView.setB3D(b3d);
                   cameraTopView.startViewing();
                   cameraSideView.startViewing();
                   scaleWidget.setB3D(b3d);
               }
               
               border.setCenter(translateCameraViews);
            }
        });
        
        Image extrudeImg = new Image(getClass().getResourceAsStream("/resources/extrude.png"));
        Button buttonExtrude = new Button();
        buttonExtrude.setGraphic(new ImageView(extrudeImg));

        buttonExtrude.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
               
                BoxModelObject b3d = getSelectedB3D();
                if(b3d != null){
                    ew.setB3D(b3d);
                    b3d.setWireFrame();
                    border.setCenter(ew);
                }
                
            }
        });
        
        Image saveImg = new Image(getClass().getResourceAsStream("/resources/save.png"));
        Button buttonSave = new Button();
        buttonSave.setGraphic(new ImageView(saveImg));
        buttonSave.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
               
                try {
                    MeshUtils.saveScene(objects);
                } catch (IOException ex) {
                    Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                }
                
            }
        });
        
        Image loadImg = new Image(getClass().getResourceAsStream("/resources/load.png"));
        Button buttonLoad = new Button();
        buttonLoad.setGraphic(new ImageView(loadImg));
        buttonLoad.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
               
                loadSceneFromFile();   
                
            }
        });
        
        Image undoImg = new Image(getClass().getResourceAsStream("/resources/undo.png"));
        Button buttonUndo = new Button();
        buttonUndo.setGraphic(new ImageView(undoImg));
        buttonUndo.setOnAction(new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
               
                
                
            }
        });

        VBox icons = new VBox(buttonModel, buttonExtrude ,buttonTranslate, buttonColor, buttonSave, buttonLoad , buttonUndo);
        return icons;

    }
    
    private BoxModelObject getSelectedB3D(){
        BoxModelObject b = null;
        for(BoxModelObject b3d:objects){
            if(b3d.isSelected())
                b = b3d;
        }
        
        return b;
    }

    private void selectB3d(BoxModelObject b) {
      
        if(b.equals(getSelectedB3D())){
            return;
        }
        for (BoxModelObject b3d : objects) {
            if (!b.equals(b3d)) {
                b3d.setSelected(false);
            }
        }
        b.setSelected(true);
        bmw.setB3D(b);
        ew.setB3D(b);
        ew.setCamPos(new Point3D(camera.getTranslateX(),camera.getTranslateY(),camera.getTranslateZ()));
        b.setEW(ew);
        scaleWidget.setB3D(b);
        colorWidget.setB3D(b);
        cameraTopView.setB3D(b);
        cameraSideView.setB3D(b);

    }

    private void buildCamera() {
        world.getChildren().add(cameraXform);
        cameraXform.getChildren().add(cameraXform2);
        cameraXform2.getChildren().add(cameraXform3);
        cameraXform3.getChildren().add(camera);

        camera.setNearClip(0.1);
        camera.setFarClip(10000.0);
        camera.setTranslateZ(-cameraDistance);
        cameraXform.rx.setAngle(-10);
        
        
    }

    
    
    private void handleMouse(Scene scene, final Node root) {
        scene3D.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent me) {
                mousePosX = me.getSceneX();
                mousePosY = me.getSceneY();
                mouseOldX = me.getSceneX();
                mouseOldY = me.getSceneY();
            }
        });
        scene3D.setOnMouseDragged(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent me) {
                mouseOldX = mousePosX;
                mouseOldY = mousePosY;
                mousePosX = me.getSceneX();
                mousePosY = me.getSceneY();
                mouseDeltaX = (mousePosX - mouseOldX);
                mouseDeltaY = (mousePosY - mouseOldY);

                double modifier = 1.0;
                double modifierFactor = 0.1;

                if (me.isControlDown()) {
                    modifier = 0.1;
                }
                if (me.isShiftDown()) {
                    modifier = 10.0;
                }
                if (me.isPrimaryButtonDown()) {
                    cameraXform.ry.setAngle(cameraXform.ry.getAngle() + mouseDeltaX * modifierFactor * modifier * 2.0);  // +
                    cameraXform.rx.setAngle(cameraXform.rx.getAngle() - mouseDeltaY * modifierFactor * modifier * 2.0);  // -
                } else if (me.isSecondaryButtonDown()) {
                    double z = camera.getTranslateZ();
                    double newZ = z + mouseDeltaX * modifierFactor * modifier;
                    camera.setTranslateZ(newZ);
                } else if (me.isMiddleButtonDown()) {
                    cameraXform2.t.setX(cameraXform2.t.getX() + mouseDeltaX * modifierFactor * modifier * 0.3);  // -
                    cameraXform2.t.setY(cameraXform2.t.getY() + mouseDeltaY * modifierFactor * modifier * 0.3);  // -
                }
                if(bmw.getB3D() != null){
                   // bmw.getB3D().setCameraAngle(cameraXform.rx.getAngle(), cameraXform.ry.getAngle());
                }
                if(ew != null){
                    ew.setSceneCameraAngles(cameraXform.rx.getAngle(), cameraXform.ry.getAngle());
                    ew.setCamPos(new Point3D(camera.getTranslateX(),camera.getTranslateY(),camera.getTranslateZ()));
                }
            }
        });
        
        border.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent me) {
                mousePosX = me.getSceneX();
                mousePosY = me.getSceneY();
                mouseOldX = me.getSceneX();
                mouseOldY = me.getSceneY();
            }
        });
        border.setOnMouseDragged(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent me) {
                mouseOldX = mousePosX;
                mouseOldY = mousePosY;
                mousePosX = me.getSceneX();
                mousePosY = me.getSceneY();
                mouseDeltaX = (mousePosX - mouseOldX);
                mouseDeltaY = (mousePosY - mouseOldY);

                double modifier = 1.0;
                double modifierFactor = 0.1;

                if (me.isPrimaryButtonDown()) {
                    cameraXform.ry.setAngle(cameraXform.ry.getAngle() + mouseDeltaX * modifierFactor * modifier * 2.0);  // +
                    cameraXform.rx.setAngle(cameraXform.rx.getAngle() - mouseDeltaY * modifierFactor * modifier * 2.0);
                    //System.out.println("Angulo X: "+cameraXform.rx.getAngle());// -
                    if(ew != null){
                        ew.setSceneCameraAngles(cameraXform.rx.getAngle(), cameraXform.ry.getAngle());
                        ew.setCamPos(new Point3D(camera.getTranslateX(),camera.getTranslateY(),camera.getTranslateZ()));
                        //System.out.println("Cam Pos: "+new Point3D(camera.getTranslateX(),camera.getTranslateY(),camera.getTranslateZ()));
                        ew.setNav(true);
                    }
                }   
            }
        });
        border.setOnMouseReleased(new EventHandler<MouseEvent>(){

            @Override
            public void handle(MouseEvent event) {
                ew.setNav(false);
            }
        
        });
        
        
        scene3D.setOnZoom((ZoomEvent event)->{

           
            double z = camera.getTranslateZ();
            double newZ = z * event.getZoomFactor();// + mouseDeltaX * modifierFactor * modifier;
            camera.setTranslateZ(newZ);
            event.consume();
        });
        
        border.setOnZoom((ZoomEvent event)->{

           
            double z = camera.getTranslateZ();
            double newZ = z * event.getZoomFactor();// + mouseDeltaX * modifierFactor * modifier;
            camera.setTranslateZ(newZ);
            event.consume();
        });
    }
    

    private BorderPane createInterface() {

        border = new BorderPane();
        border.setPrefSize(1920,1080);
        border.setPickOnBounds(true);
        border.setPadding(new Insets(20, 0, 20, 20));
        HBox icons = addIconBox();
        border.setTop(icons);

        border.setLeft(addToolIcons());
        
 

        return border;
    }

    private SubScene create3DScene(Group group) {
        scene3D = new SubScene(group, 1920, 1080, true, SceneAntialiasing.BALANCED);
        scene3D.setPickOnBounds(true);
        scene3D.setCamera(camera);
        
        cameraTopView = new CameraViewOrtho(scene3D, CameraViewOrtho.TOP_VIEW);       
        cameraTopView.setFitWidth(500);
        cameraTopView.setFitHeight(500);
        
        
        
        cameraSideView = new CameraViewOrtho(scene3D, CameraViewOrtho.SIDE_VIEW);       
        cameraSideView.setFitWidth(500);
        cameraSideView.setFitHeight(500);
        
        
        scaleWidget = new ScaleWidget();
        translateCameraViews = new HBox(cameraSideView, cameraTopView, scaleWidget);
        translateCameraViews.setSpacing(10);
        
        return scene3D;
    }

    @Override
    public void start(Stage primaryStage) {
        
        stage = primaryStage;
        
        buildScene();
        buildCamera();
        SubScene subScene = create3DScene(world);
        ew = new ExtrusionWidget.Builder(subScene).build();
                
        VBox layout = new VBox(
                subScene,
                createInterface()
        );

        Scene scene = new Scene(layout, 1920, 2160, true);
        scene.setFill(Color.GREY);
        
        
        
        

        handleMouse(scene, scene3D);

        //The following code shows the application as undecorated fullscreen window with the dimension 1920 x 2160 
        Rectangle2D primaryScreenBounds = Screen.getPrimary().getVisualBounds();
        primaryStage.setX(primaryScreenBounds.getMinX() + primaryScreenBounds.getWidth() - 1920);
        primaryStage.setY(primaryScreenBounds.getMinY() + primaryScreenBounds.getHeight() - 1080);
        primaryStage.setWidth(1920);
        primaryStage.setHeight(2160);
        primaryStage.initStyle(StageStyle.UNDECORATED);
        primaryStage.setTitle("3D Test Application");
        primaryStage.setScene(scene);
        primaryStage.show();

    }

    /**
     * The main() method is ignored in correctly deployed JavaFX application.
     * main() serves only as fallback in case the application can not be
     * launched through deployment artifacts, e.g., in IDEs with limited FX
     * support. NetBeans ignores main().
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        System.setProperty("prism.dirtyopts", "false");
        launch(args);
    }

}
