/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg3dtestapplication;

import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.scene.input.RotateEvent;
import javafx.scene.input.ScrollEvent;
import javafx.scene.input.TouchEvent;
import javafx.scene.input.ZoomEvent;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;

/**
 *
 * @author henri
 */
public class ScaleWidget extends Group{
    
    private Rectangle widgetArea, xBar, yBar, zBar;
    private Group modeButton;

    Image scaleImg, rotateImg;
    ImageView scaleIcon, rotateIcon;
    
    private BoxModelObject b3d;
    
    private int mode;
    
    public final static int SCALE = 0;
    public final static int ROTATE = 1;
    
    private ImageView gizmoScale, gizmoRotate;
    
    public ScaleWidget(){
    
        widgetArea = new Rectangle(500,500);
        
        scaleImg = new Image(getClass().getResourceAsStream("/resources/gizmoScale.png"));
        scaleIcon = new ImageView(scaleImg);
        
        rotateImg = new Image(getClass().getResourceAsStream("/resources/gizmoRotate.png"));
        rotateIcon = new ImageView(rotateImg);
        
       
        this.mode = ScaleWidget.SCALE;
        modeButton = new Group();
        modeButton.getChildren().add(rotateIcon);
        modeButton.setTranslateX(450);
        modeButton.setOnTouchPressed((TouchEvent event) -> {
                if (mode == ScaleWidget.SCALE) {
                    mode = ScaleWidget.ROTATE;
                    modeButton.getChildren().remove(rotateIcon);
                    modeButton.getChildren().add(scaleIcon);
                } else {
                    mode = ScaleWidget.SCALE;
                    modeButton.getChildren().remove(scaleIcon);
                    modeButton.getChildren().add(rotateIcon);
                }

        });
        
        
        
        
        xBar = new Rectangle(450,50);
        xBar.setFill(Color.RED);
        
        yBar = new Rectangle(50,400);
        yBar.setTranslateX(450);
        yBar.setTranslateY(50);
        yBar.setFill(Color.GREEN);
        
        zBar = new Rectangle(450,50);
        zBar.setTranslateY(450);
        zBar.setFill(Color.BLUE);
        
        widgetArea.setOnZoom((ZoomEvent event) -> {
            double factor = event.getZoomFactor();
            if(this.mode == ScaleWidget.SCALE){
                b3d.s.setX(b3d.s.getX() * factor);
                b3d.s.setY(b3d.s.getY() * factor);
                b3d.s.setZ(b3d.s.getZ() * factor);
            }
            event.consume();
        });
        
        widgetArea.setOnRotate((RotateEvent event) -> {
            double factor = event.getAngle();
            if(this.mode == ScaleWidget.ROTATE){
                this.b3d.rx.setAngle(this.b3d.rx.getAngle() + factor);
                this.b3d.ry.setAngle(this.b3d.ry.getAngle() + factor);
                this.b3d.rz.setAngle(this.b3d.rz.getAngle() + factor);
            }
            event.consume();
        });
        
        xBar.setOnScroll((ScrollEvent event) -> { 
            double factor = event.getDeltaX();
            if(this.mode == ScaleWidget.SCALE){
                factor = mapValue(factor,-10,10,0.9,1.1);
                b3d.s.setX(b3d.s.getX() * factor);
            }else if(this.mode == ScaleWidget.ROTATE){
                this.b3d.rx.setAngle(this.b3d.rx.getAngle() + factor);
            }
            event.consume();
        });
        
        yBar.setOnScroll((ScrollEvent event) -> { 
            double factor = event.getDeltaY();
            if(this.mode == ScaleWidget.SCALE){
                factor = mapValue(factor,-10,10,0.9,1.1);
                b3d.s.setY(b3d.s.getY() * factor);
            }else if(this.mode == ScaleWidget.ROTATE){
                this.b3d.ry.setAngle(this.b3d.ry.getAngle() + factor);
            }
            event.consume();
        });
        
        zBar.setOnScroll((ScrollEvent event) -> { 
            double factor = event.getDeltaX();
            if(this.mode == ScaleWidget.SCALE){
                factor = mapValue(factor,-10,10,0.9,1.1);
                b3d.s.setZ(b3d.s.getZ() * factor);
            }else if(this.mode == ScaleWidget.ROTATE){
                this.b3d.rz.setAngle(this.b3d.rz.getAngle() + factor);
            }
            event.consume();
        });
        
        this.getChildren().addAll(widgetArea, xBar, yBar, zBar, modeButton);

        this.addEventFilter(
                MouseEvent.ANY,
                new EventHandler<MouseEvent>() {
                    public void handle(final MouseEvent mouseEvent) {

                        mouseEvent.consume();

                    }
                });
    }
    
    public void setB3D(BoxModelObject b3d){
        this.b3d = b3d;
    }
    
    private double mapValue(double value, double oldLow, double oldHigh, double newLow, double newHigh) {
        return (value - oldLow) / (oldHigh - oldLow) * (newHigh - newLow) + newLow;
    }
    
}
